<?xml version="1.0" encoding="UTF-8"?>
<!--
Copyright (C) 2015  Stephan Kreutzer

This file is part of mobileread_wiki_ebook_list_validator1.

mobileread_wiki_ebook_list_validator1 is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License version 3 or any later version,
as published by the Free Software Foundation.

mobileread_wiki_ebook_list_validator1 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License 3 for more details.

You should have received a copy of the GNU Affero General Public License 3
along with mobileread_wiki_ebook_list_validator1. If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" doctype-public="-//W3C//DTD XHTML 1.1//EN" doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd"/>

  <xsl:template match="/downloads">
    <xsl:comment> This file was generated by transform_result.xsl for mobileread_wiki_ebook_list_validator1, which is free software licensed under the GNU Affero General Public License 3 or any later version (see https://github.com/publishing-systems/clients/ and http://www.publishing-systems.org). </xsl:comment><xsl:text>&#xA;</xsl:text>
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
      <head>
        <title>Ergebnis von mobileread_wiki_ebook_list_validator1</title>
        <meta http-equiv="content-type" content="application/xhtml+xml; charset=UTF-8" />
        <style type="text/css">
          h2
          {
              text-align: center;
          }

          .no_result
          {
              color: red;
          }

          .error
          {
              color: red;
          }

          .warning
          {
              color: orange;
          }

          .valid
          {
              color: green;
          }
        </style>
      </head>
      <body>
        <div>
          <h2>Gültigkeit der deutschen EPUBs</h2>
          <p>
            Zur <a href="uploader_statistics.xhtml">Bestenliste</a>.
          </p>
          <div>
            <table>
              <tr>
                <th>Status</th>
                <th>Details</th>
                <th>Uploader</th>
                <th>Quelle</th>
                <th>Name</th>
              </tr>
              <xsl:apply-templates/>
            </table>
            <p>
              <a href="downloads.xml">Quelle</a>, <a href="transform_result.xsl">Stylesheet</a>.
            </p>
          </div>
        </div>
      </body>
    </html>
  </xsl:template>

  <xsl:template match="//download">
    <tr>
      <td>
        <xsl:choose>
          <xsl:when test="@result = 'no_result'">
            <span class="no_result">Aufruf</span>
          </xsl:when>
          <xsl:when test="@result = 'error'">
            <span class="error">Fehler</span>
          </xsl:when>
          <xsl:when test="@result = 'warning'">
            <span class="warning">Warnung</span>
          </xsl:when>
          <xsl:when test="@result = 'valid'">
            <span class="valid">gültig</span>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@result"/>
          </xsl:otherwise>
        </xsl:choose>
      </td>
      <td>
        <xsl:choose>
          <xsl:when test="@result = 'error'">
            <a href="result_{@id}.log">Details</a>
          </xsl:when>
          <xsl:when test="@result = 'warning'">
            <a href="result_{@id}.log">Details</a>
          </xsl:when>
        </xsl:choose>
      </td>
      <td>
        <xsl:choose>
          <xsl:when test="@result = 'no_result'">
            <xsl:value-of select="@user"/>
          </xsl:when>
          <xsl:when test="@result = 'error'">
            <a href="{@user_link}"><xsl:value-of select="@user"/></a>
          </xsl:when>
          <xsl:when test="@result = 'warning'">
            <a href="{@user_link}"><xsl:value-of select="@user"/></a>
          </xsl:when>
          <xsl:when test="@result = 'valid'">
            <a href="{@user_link}"><xsl:value-of select="@user"/></a>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@user"/>
          </xsl:otherwise>
        </xsl:choose>
      </td>
      <td>
        <a href="{@origin}">Quelle</a>
      </td>
      <td>
        <xsl:value-of select="@name"/>
      </td>
    </tr>
  </xsl:template>

  <xsl:template match="text()|@*"/>

</xsl:stylesheet>
